"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("./service");
var path = require("path");
var fs = require("fs");
var mkdirp = require("mkdirp");
var pact = require("@pact-foundation/pact-standalone");
var checkTypes = require("check-types");
var Server = (function (_super) {
    __extends(Server, _super);
    function Server(options) {
        return _super.call(this, pact.mockServicePath + " service", options, {
            "port": "--port",
            "host": "--host",
            "log": "--log",
            "ssl": "--ssl",
            "sslcert": "--sslcert",
            "sslkey": "--sslkey",
            "cors": "--cors",
            "dir": "--pact_dir",
            "spec": "--pact_specification_version",
            "pactFileWriteMode": "--pact-file-write-mode",
            "consumer": "--consumer",
            "provider": "--provider"
        }) || this;
    }
    Server.create = function (options) {
        if (options === void 0) { options = {}; }
        options.dir = options.dir ? path.resolve(options.dir) : process.cwd();
        options.pactFileWriteMode = options.pactFileWriteMode || "overwrite";
        if (options.spec) {
            checkTypes.assert.number(options.spec);
            checkTypes.assert.integer(options.spec);
            checkTypes.assert.positive(options.spec);
        }
        if (options.dir) {
            try {
                fs.statSync(path.normalize(options.dir)).isDirectory();
            }
            catch (e) {
                mkdirp.sync(path.normalize(options.dir));
            }
        }
        if (options.consumer) {
            checkTypes.assert.string(options.consumer);
        }
        if (options.provider) {
            checkTypes.assert.string(options.provider);
        }
        checkTypes.assert.includes(["overwrite", "update", "merge"], options.pactFileWriteMode);
        return new Server(options);
    };
    return Server;
}(service_1.AbstractService));
exports.Server = Server;
exports.default = Server.create;
//# sourceMappingURL=server.js.map